
package com.dcy.android_foreground_alive;

import androidx.annotation.NonNull;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

import android.content.IntentFilter;
import android.provider.Settings;
import android.content.Intent;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import android.util.Log;
import android.widget.Toast;

import com.dcy.android_foreground_alive.DcyForegroundService;
import com.dcy.android_foreground_alive.PlayerMusicService;


/** FlutterPushSettingPlugin */
public class AndroidForegroundAlivePlugin implements FlutterPlugin, MethodCallHandler, ActivityAware {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;

  private ActivityPluginBinding pbinding;

  private boolean isRegisterReceiver = false;

//  private static PluginRegistry.Registrar registrar;

  /** Plugin registration. */
//  public static void registerWith(Registrar registrar) {
//    FlutterPushSettingPlugin.registrar = registrar;
//    FlutterPushSettingPlugin plugin = new FlutterPushSettingPlugin();
//    plugin.setupMethodChannel(registrar.messenger(), registrar.context().getContentResolver());
//  }

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "android_foreground_alive");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android ---" + android.os.Build.VERSION.RELEASE);
    } else if (call.method.equals("startForegroundAlive")){
      //推送
      Intent intentp = new Intent(pbinding.getActivity(), DcyForegroundService.class);
      // 启动指定Service
      pbinding.getActivity().startService(intentp);
      //一颗像素
      //注册监听屏幕开启和关闭的广播
//      if(!isRegisterReceiver){
//        isRegisterReceiver = true;

//        IntentFilter intentFilter = new IntentFilter();
//        intentFilter.addAction("android.intent.action.SCREEN_OFF");
//        intentFilter.addAction("android.intent.action.SCREEN_ON");
//        intentFilter.addAction("android.intent.action.USER_PRESENT");
//        pbinding.getActivity().registerReceiver(mOnepxReceiver, intentFilter);
//      }

      //音乐
      Intent intent = new Intent(pbinding.getActivity(), PlayerMusicService.class);
      pbinding.getActivity().startService(intent);
      result.success("Android +++" + android.os.Build.VERSION.RELEASE);
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }

  @Override
  public void onAttachedToActivity(ActivityPluginBinding binding) {

    pbinding = binding;

  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {
    this.onDetachedFromActivity();
  }

  @Override
  public void onReattachedToActivityForConfigChanges(ActivityPluginBinding binding) {
    this.onAttachedToActivity(binding);
  }

  @Override
  public void onDetachedFromActivity() {
//    if(isRegisterReceiver){
//      pbinding.getActivity().unregisterReceiver(mOnepxReceiver);
//      isRegisterReceiver = false;
//    }
    pbinding = null;

  }


}
