import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:android_foreground_alive/android_foreground_alive.dart';

void main() {
  const MethodChannel channel = MethodChannel('android_foreground_alive');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    expect(await AndroidForegroundAlive.platformVersion, '42');
  });
}
